\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}


\\-----------------------------------------------------------------------------
n_string_for_other(n) =
{
  my(v=binary(n),str="");
  my(i=#v);
  while(i>=1 && v[i]==0,
        str=Str("_",v[i],str); i--);
  if(i<1,return(str));

  str=Str(v[i],str); i--;       \\ low 1-bit
  if(i<1,return(Str("S [...0] 0 ",str)));

  t=v[i];
  str=Str(v[i]," ",str); i--;   \\ t bit

  while(1,
        str=Str(" ",str);
        if(i<1,return(Str("S [...0]",str)));

        my(bit=v[i]);
        while(i>=1 && v[i]==bit,          \\ run of bits
              str=Str("+",v[i],str); i--);
        if(i<1,
           if(bit==1&&t==1,return(Str("D [t!=0] [0]",str)));
           return(Str("S ...",str))); \\ infinite run (of 1s)

        str=Str(v[i],str); i--;         \\ ending bit
        if(i<1,
           return(if(t==0,Str("S ...",str),
                     Str("D [t!=0] ",str))));

        str=Str(v[i]," ",str);
        if(v[i]!=t,                     \\ !=t is end
           i--;
           if(i>=1,
              str=Str(") ",str);
              while(i>=1, str=Str(v[i],str); i--);
              str=Str("D (",str));
           return(str));
       );
}

{
  for(n=0,255,
     printf("%2d %40s %10d%s%s\n",
            n,n_string_for_other(n),to_binary(n)
            if(DpredInf(n)," D","")
            if(n%2==0 && DpredInf(n/2)," d","")));
}
