\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

P910norm(k) = {
  13/36 * 2^k
  + 1/9 * vector_modulo([-2, 11, 2, -11],k) * 2^floor(k/2)
  + 1/9 * vector_modulo([1, 5],k);
}
vector(100,k,k++; gcd(P910norm(k),P910norm(k+1)))

{
  for(k=6,10,
     my(v = gcdext(P910norm(k),P910norm(k+1)));
     print(v[1]",");
     );
}

a(k) =
{
  13/18 * 2^k
  + 1/9 * vector_modulo([-2, 11, 2, -11],k+1) * 2^floor((k+1)/2)
  + 1/9 * vector_modulo([1, 5],k+1);
}
b(k) =
{
  13/36 * 2^k
  + 1/9 * vector_modulo([-2, 11, 2, -11],k) * 2^floor(k/2)
  + 1/9 * vector_modulo([1, 5],k);
}
check_exact(vector(100,k,k+=5; a(k)), \
            vector(100,k,k+=5; P910norm(k+1)))
check_exact(vector(100,k,k+=5; b(k)), \
            vector(100,k,k+=5; P910norm(k)))

d_ref(k) = {
 a(k) - 2*b(k);
}
d(k) = {
  + vector_modulo([5/3, -2, -5/3, 2],k) * 2^floor(k/2)
  + vector_modulo([1/3, -1],k)
  ;
}
check_exact(vector(100,k,k+=5; d(k)), \
            vector(100,k,k+=5; d_ref(k)))


a(k) =
{
  13/18 * 2^k
  + 1/9 * vector_modulo([-2, 11, 2, -11],k+1) * 2^floor((k+1)/2)
  + 1/9 * vector_modulo([1, 5],k+1);
}
b(k) =
{
  + vector_modulo([5/3, 2, 5/3, 2],k) * 2^floor(k/2)
  + vector_modulo([1/3, 1, -1/3, -1],k);
}
d_ref(k) = {
 if(k==0,0, a(k) % b(k));
}
\\ vector(100,k,k--; d_ref(k))

check_exact(vector(100,k,k--; (1/6)* vector_modulo([0, -1, -1, 0, 1, 1],k)), \
            gf_terms((-1/6*x)/(1 - x + x^2),100))
check_exact(vector(100,k,k--; (1/6)* vector_modulo([0, -1, 1, 0, -1, 1],k)), \
            gf_terms((-1/6*x)/(1 + x + x^2),100))
{
  check_exact(vector(100,k,k--;
                     vector_modulo([1/6, 0, -1/2, 0, -1/6, 0, 1/2, 0],k)
                     *2^floor(k/2)), \
            gf_terms( (1/12 - 1/3*x)/(1 - 2*x + 2*x^2)
                     + (1/12 + 1/3*x)/(1 + 2*x + 2*x^2),100));
}
{
check_exact(vector(100,k,k--;
                   vector_modulo([0, -2/3, 0, -2/3, 0, 0, 0, 2/3, 0, 2/3, 0, 0],k)
                   * 2^floor(k/2)),
            gf_terms((-2/3*x)/(1 - 2*x^2 + 4*x^4),100));
}
{
  check_exact(vector(100,k,k--;
                     vector_modulo([0, 0, 0, 2/3, 0, 2/3, 0, 0, 0, -2/3, 0, -2/3],k)
                     * 2^floor(k/2)), \
              gf_terms(( 4/3*x^3)/(1 - 2*x^2 + 4*x^4),100));
}
gd(x) = {
     + -3/2 + 3/2*x
     + (1/4)/(1 - x)
     + (1/12)/(1 + x)
     + (1/6 + 1/2*x)/(1 + x^2)
     + (-1/6*x)/(1 - x + x^2)
     + (-1/6*x)/(1 + x + x^2)

     + (5/6 + x)/(1 - 2*x^2)
     + (-1/30 - 1/6*x)/(1 + 2*x^2)
     + (1/12 - 1/3*x)/(1 - 2*x + 2*x^2)
     + (1/12 + 1/3*x)/(1 + 2*x + 2*x^2)

     + (1/30 + 1/10*x^2)/(1 + x^4)
     + (-2/3*x + 4/3*x^3)/(1 - 2*x^2 + 4*x^4)
}
check_exact(gf_terms(gd(x),100), vector(100,k,k--; if(k==0,0, d_ref(k))), "gd");

d(k) =
{
  if(k==0,return(0));
  if(k==1,return(2));
  + 1/4
  + (1/12)* vector_modulo([1, -1],k)
  + (1/6)* vector_modulo([1, 3, -1, -3],k)
  + (1/6)* vector_modulo([0, -1, -1,  0, 1, 1],k)
  + (1/6)* vector_modulo([0, -1, 1, 0, -1, 1],k)

  + (1/6)* vector_modulo([5, 6],k) * 2^floor(k/2)
  + (1/30)* vector_modulo([-1, -5, 1, 5],k) * 2^floor(k/2)
  + vector_modulo([1/6, 0, -1/2, 0, -1/6, 0, 1/2, 0],k)
                     *2^floor(k/2)

  + (1/30)* vector_modulo([1, 0, 3, 0, -1, 0, -3, 0],k)

  + vector_modulo([0, -2/3, 0, -2/3, 0, 0, 0, 2/3, 0, 2/3, 0, 0],k)
  * 2^floor(k/2)
  + vector_modulo([0, 0, 0, 2/3, 0, 2/3, 0, 0, 0, -2/3, 0, -2/3],k)
  * 2^floor(k/2)
  ;
}
check_exact(vector(100,k,k--; d(k)), \
            gf_terms(gd(x),100), "d vs gd");
check_exact(vector(100,k,k+=5; d(k)), \
            vector(100,k,k+=5; d_ref(k)), "d")

d(k) =
{
  if(k==0,return(0));
  if(k==1,return(2));

  vector_modulo([29/30, 1/6, 11/30, 7/6, 19/30, 3/2, 41/30, 11/6,
                 29/30, 5/6, 11/30, 1/2, 19/30, 1/6, 41/30, 7/6,
                 29/30, 3/2, 11/30, 11/6, 19/30, 5/6, 41/30, 1/2],k)
  * 2^floor(k/2)

  + vector_modulo([8/15, 1/3, 4/15, -1/3, 7/15, 1, 1/15, -2/3,
                   8/15, 2/3, 4/15, 0, 7/15, 1/3, 1/15, -1/3,
                   8/15, 1, 4/15, -2/3, 7/15, 2/3, 1/15, 0],k)
  ;
}
check_exact(vector(100,k,k+=5; d(k)), \
            vector(100,k,k+=5; d_ref(k)), "d")


\\------------
a(k) =
{
  vector_modulo([29/30, 1/6, 11/30, 7/6, 19/30, 3/2, 41/30, 11/6,
                 29/30, 5/6, 11/30, 1/2, 19/30, 1/6, 41/30, 7/6,
                 29/30, 3/2, 11/30, 11/6, 19/30, 5/6, 41/30, 1/2],k)
  * 2^floor(k/2)

  + vector_modulo([8/15, 1/3, 4/15, -1/3, 7/15, 1, 1/15, -2/3,
                   8/15, 2/3, 4/15, 0, 7/15, 1/3, 1/15, -1/3,
                   8/15, 1, 4/15, -2/3, 7/15, 2/3, 1/15, 0],k);
}
b(k) =
{
  + vector_modulo([5/3, 2, 5/3, 2],k) * 2^floor(k/2)
  + vector_modulo([1/3, 1, -1/3, -1],k);
}
d_ref(k) = {
 if(k==0,0, b(k) % a(k));
}
 vector(100,k,k--; gcd(a(k),b(k)))
 vector(100,k,k--; d_ref(k))
quit
vector(16,k,k+=15; to_binary(P910norm(k) \ f(k)))
{
vector(16,k,k+=15;
       P910norm(k) -
       vector_modulo([13/36/(5/3), 13/36/(-6/3), 13/36/(-5/3), 13/36/(6/3)],k) * 2^ceil(k/2) * f(k))
}




