#!/usr/bin/perl -w

# Copyright 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use List::Util 'min';
use Math::BaseCnv;
use Math::BigInt;

use FindBin;
use lib $FindBin::Bin;
use MyDragon '@Rpred_state_table','@Rpred_state_to_name','@Rpred_state_to_sides';
use MyPrintwrap ':all';
use MyFLAT;
$|=1;


print "% generated by tools/$FindBin::Script\n";
my $max_len = Math::BigInt->new(32);

foreach my $state (0 .. $#Rpred_state_table) {
  print "% GP-DEFINE  Rpred_$Rpred_state_to_name[$state] = ",$state+1,";\n";
}

{
  my $prefix = "Rpred_state_table = {[";
  foreach my $state (0 .. $#Rpred_state_table) {
    my $semi = $state == $#Rpred_state_table ? ' ]};' : ';   ';
    printf "%% GP-DEFINE  %s %2d,%2d%s  \\\\ %2d  %s\n",
      $prefix,
      $Rpred_state_table[$state]->[0] + 1,
      $Rpred_state_table[$state]->[1] + 1,
      $semi,
      $state + 1,
      $Rpred_state_to_name[$state];
    $prefix = ' ' x length($prefix);
  }
}

printwrap_indent("% GP-DEFINE  ");
printwrap_gp_vector([ map{"\"$_\""} @Rpred_state_to_name ],
                    "Rpred_state_to_name");

printwrap_gp_vector(\@Rpred_state_to_sides,
                    "Rpred_state_to_sides");


print "% end generated\n";
exit 0;
